attribute highp vec4 a_position;
attribute lowp vec4 a_color;
attribute mediump vec2 a_texCoord;

uniform highp mat4 u_modelViewProjectionMatrix;
uniform lowp vec4 u_materialAmbient;

varying lowp vec4 v_color;
varying mediump vec2 v_texCoord;
varying mediump vec4 v_distance;

void main() {
	gl_Position = u_modelViewProjectionMatrix * a_position;
	v_color = a_color * vec4(u_materialAmbient.a, u_materialAmbient.a, u_materialAmbient.a, 1.0);
	v_texCoord = a_texCoord;
	mediump float rg = 1.0 + smoothstep(300.0, 1600.0, abs(gl_Position.z));
	v_distance = vec4(rg, rg, 1.0 + smoothstep(200.0, 800.0, abs(gl_Position.z)), 1.0);
}